Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15189)
@@ -6,4 +6,5 @@
   using System.Diagnostics;
   using System.Linq;
+  using System.Text;
   using System.Threading;
   using DirtyList;
@@ -44,5 +45,5 @@
       //PerformanceParallelTestInterpreter();
       //PerformanceTestLinearCodeGenerator();
-      TestRobustness();
+      //TestRobustness();
       //TestPool();
       //TestPoolPerformance();
@@ -51,7 +52,19 @@
       //TestExpressionDependencies();
       //TestSplitLogic();
+      TestStringBuilder();
 
       Console.WriteLine("\nPress any key to continue...");
       Console.ReadKey(false);
+    }
+
+    private static void TestStringBuilder() {
+      var sb = new StringBuilder();
+      sb.Append("test");
+
+      var s1 = sb.ToString();
+      var s2 = sb.ToString();
+
+      // false
+      var equal = ReferenceEquals(s1, s2);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15189)
@@ -30,31 +30,4 @@
     protected abstract Example ParseExample(string[] input, string[] output);
 
-    //private IEnumerable<Example> ParseData() {
-    //  using (var file = GetType().Assembly.GetManifestResourceStream(InstanceArchiveName))
-    //  using (var archive = new ZipArchive(file, ZipArchiveMode.Read)) {
-    //    var entry = archive.Entries.SingleOrDefault(x => x.Name == FileName);
-
-    //    using (var parser = new TextFieldParser(entry.Open())) {
-    //      parser.TextFieldType = FieldType.Delimited;
-    //      parser.SetDelimiters(ExampleFieldDelimiter);
-    //      parser.HasFieldsEnclosedInQuotes = true;
-    //      parser.TrimWhiteSpace = false;
-
-    //      //Processing rows
-    //      while (!parser.EndOfData) {
-    //        var fields = parser.ReadFields();
-
-    //        if (fields.Length != InputArgumentCount + OutputArgumentCount)
-    //          throw new InvalidDataException("Number of values do not fit");
-
-    //        var input = fields.Take(InputArgumentCount).ToArray();
-    //        var output = fields.Skip(InputArgumentCount).ToArray();
-
-    //        yield return ParseExample(input, output);
-    //      }
-    //    }
-    //  }
-    //}
-
     private IEnumerable<Example> ParseData() {
       using (var file = GetType().Assembly.GetManifestResourceStream(InstanceArchiveName))
@@ -69,5 +42,7 @@
             var output = line.Skip(InputArgumentCount).ToArray();
 
-            yield return ParseExample(input, output);
+            var example = ParseExample(input, output);
+
+            yield return example;
           }
         }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15189)
@@ -34,4 +34,5 @@
       ErcOptions = cloner.Clone(origin.ErcOptions);
       FloatStringFormat = origin.FloatStringFormat;
+      ProblemType = origin.ProblemType;
     }
 
@@ -51,5 +52,9 @@
     [Storable]
     public ExampleArgumentType[] OutputArgumentTypes { get; set; }
+
+    public int TotalIntputArgumentCount { get { return InputArgumentTypes.Length; } }
+    public int TotalOutputArgumentCount { get { return OutputArgumentTypes.Length; } }
     public int TotalArgumentCount { get { return InputArgumentTypes.Length + OutputArgumentTypes.Length; } }
+
     [Storable]
     public Example[] Examples { get; set; }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 15189)
@@ -2,4 +2,5 @@
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Char;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.String;
 
   public class Checksum : BenchmarkSuiteDataDescriptor {
@@ -35,5 +36,7 @@
           CharErcOptions = new CharErcOptions(
             new IntegerConstantErc(' '),
-            new IntegerRangeErc(0x20, 0x7e))
+            new IntegerRangeErc(0x20, 0x7e)),
+          StringErcOptions = new StringErcOptions(
+            new StringConstantErc("Check sum is "))
         }
       };
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15189)
@@ -24,8 +24,8 @@
         WorstResult = 400,
         InputArgumentTypes = new[] { ExampleArgumentType.Float, ExampleArgumentType.Integer },
-        OutputArgumentTypes = new[] { ExampleArgumentType.Float },
+        OutputArgumentTypes = new[] { ExampleArgumentType.Print },
         TrainingCount = 25,
         TestCount = 1000,
-        EnabledDataTypes = DataTypes.Integer | DataTypes.Float, // | DataTypes.Print,
+        EnabledDataTypes = DataTypes.Integer | DataTypes.Float | DataTypes.Print,
         EvalLimit = 200,
         MaxSize = 200,
@@ -48,5 +48,5 @@
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input[1]),
         OutputFloat = ExampleArgumentConverter.ConvertDoubles(output),
-        //OutputPrint = estimedFloatValue.ToString("R", CultureInfo.InvariantCulture),
+        OutputPrint = estimedFloatValue.ToString("R", CultureInfo.InvariantCulture),
       };
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15189)
@@ -136,5 +136,5 @@
     <Compile Include="Push\Data\Tree\TreeExtensions.cs" />
     <Compile Include="Push\Data\Tree\TreeNode.cs" />
-    <Compile Include="Push\Constants\Environment.cs" />
+    <Compile Include="Push\Constants\PushEnvironment.cs" />
     <Compile Include="Push\Exporter\Exporter.cs" />
     <Compile Include="Push\Expressions\BooleanExpressions.cs" />
@@ -153,4 +153,5 @@
     <Compile Include="Push\Expressions\FloatExpressions.cs" />
     <Compile Include="Push\Expressions\FlushExpressions.cs" />
+    <Compile Include="Push\Expressions\InExpressions.cs" />
     <Compile Include="Push\Expressions\IntegerExpressions.cs" />
     <Compile Include="Push\Expressions\NameExpressions.cs" />
@@ -194,9 +195,12 @@
     <Compile Include="Push\Extensions\ControlExntensions.cs" />
     <Compile Include="Push\Extensions\EnumExtensions.cs" />
+    <Compile Include="Push\Extensions\ProblemDataExtensions.cs" />
     <Compile Include="Push\Extensions\LongExtensions.cs" />
     <Compile Include="Push\Extensions\RandomExtensions.cs" />
+    <Compile Include="Push\Extensions\StringBuilderExtensions.cs" />
     <Compile Include="Push\Generators\CodeGenerator\CodeGeneratorUtils.cs" />
     <Compile Include="Push\Generators\CodeGenerator\LinearCodeGenerator.cs" />
     <Compile Include="Push\Generators\CodeGenerator\RecursiveCodeGenerator.cs" />
+    <Compile Include="Push\Individual\InduvidualMapper.cs" />
     <Compile Include="Push\Interpreter\Extensions.cs" />
     <Compile Include="Push\Interpreter\IInternalPushInterpreter.cs" />
@@ -208,9 +212,10 @@
     <Compile Include="Push\Interpreter\PushInterpreter.cs" />
     <Compile Include="Push\Interpreter\PushInterpreterPool.cs" />
+    <Compile Include="Push\ObjectPools\StringBuilderPool.cs" />
     <Compile Include="Push\Parser\PushParser.cs" />
     <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteSolution.cs" />
     <Compile Include="Push\Problem\DataBounds.cs" />
     <Compile Include="Push\Problem\EvaluationResult.cs" />
-    <Compile Include="Push\Problem\IndividualMapper.cs" />
+    <Compile Include="Push\Individual\IndividualExtensions.cs" />
     <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteEvaluator.cs" />
     <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteProblem.cs" />
@@ -223,6 +228,8 @@
     <Compile Include="Push\Selector\LexicaseSelector.cs" />
     <Compile Include="Push\Simplifier\Simplifier.cs" />
+    <Compile Include="Push\Stack\IPrintStack.cs" />
     <Compile Include="Push\Stack\IPushStack.cs" />
     <Compile Include="Push\Stack\IPushStackBase.cs" />
+    <Compile Include="Push\Stack\PrintStack.cs" />
     <Compile Include="Push\Stack\PushStack.cs" />
     <Compile Include="Push\Stack\InterpreterStackStringifier.cs" />
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs	(revision 15189)
@@ -14,5 +14,5 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Individual;
 
   /// <summary>
@@ -35,5 +35,5 @@
       Parameters.Add(new LookupParameter<ResultCollection>(ResultsParameterName, "The result collection where the symbol frequencies should be stored."));
 
-      Parameters.Add(new FixedValueParameter<BoolValue>(AggregateStackTypesParameterName, "Determines if expressions should be aggregated by their primary stack type."));
+      Parameters.Add(new FixedValueParameter<BoolValue>(AggregateStackTypesParameterName, "Determines if expressions should be aggregated by their primary stack type.", new BoolValue(true)));
     }
 
@@ -84,5 +84,5 @@
       var config = PushConfigurationParameter.ActualValue;
       var integerVectors = IntegerVectorParameter.ActualValue;
-      var pushPrograms = integerVectors.Select(iv => iv.ToPushProgram(config)).ToArray();
+      var pushPrograms = integerVectors.Select(iv => iv.ToPushProgram(config));
 
       var results = ResultsParameter.ActualValue;
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15189)
@@ -48,5 +48,5 @@
       set
       {
-        var removedExpressions = enabledExpressions.ToArray();
+        var removedExpressions = enabledExpressions.ToList();
         enabledExpressions.Clear();
         enabledExpressions.AddRange(value);
@@ -68,5 +68,7 @@
         var attribute = ExpressionTable.TypeToAttributeTable[type];
 
-        expressionsPerStackCount[attribute.StackType]++;
+        if (expressionsPerStackCount.ContainsKey(attribute.StackType)) {
+          expressionsPerStackCount[attribute.StackType]++;
+        }
 
         foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues())
@@ -150,6 +152,9 @@
 
       enabledExpressions.Add(expressionName);
-      expressionsPerStackCount[attribute.StackType]++;
-      foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues())
+
+      if (expressionsPerStackCount.ContainsKey(attribute.StackType))
+        expressionsPerStackCount[attribute.StackType]++;
+
+      foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues().Where(expressionsPerStackCount.ContainsKey))
         expressionsPerStackCount[additionalStackType]++;
 
@@ -172,6 +177,9 @@
 
       enabledExpressions.Remove(expressionName);
-      expressionsPerStackCount[attribute.StackType]--;
-      foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues())
+
+      if (expressionsPerStackCount.ContainsKey(attribute.StackType))
+        expressionsPerStackCount[attribute.StackType]--;
+
+      foreach (var additionalStackType in attribute.AdditionalStackDependencies.ToValues().Where(expressionsPerStackCount.ContainsKey))
         expressionsPerStackCount[additionalStackType]--;
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/PushEnvironment.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/PushEnvironment.cs	(revision 15189)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/PushEnvironment.cs	(revision 15189)
@@ -0,0 +1,21 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Constants {
+  public static class PushEnvironment {
+    public const char VectorStartSymbol = '[';
+    public const string VectorStartSymbolStr = "[";
+    public const char VectorEndSymbol = ']';
+    public const string VectorEndSymbolStr = "]";
+    public const char VectorSeparatorSymbol = ' ';
+    public const string VectorSeparatorSymbolStr = " ";
+
+    public const char ProgramStartSymbol = '(';
+    public const string ProgramStartSymbolStr = "(";
+    public const char ProgramEndSymbol = ')';
+    public const string ProgramEndSymbolStr = ")";
+
+    public const char CharSymbol = '\'';
+    public const char StringSymbol = '\"';
+    public const string CharSymbolStr = "'";
+    public const string StringSymbolStr = "\"";
+    public const string NewLine = "\n";
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs	(revision 15189)
@@ -1,4 +1,5 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool {
   public interface IPooledObject {
+    void Init();
     void Reset();
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 15189)
@@ -10,4 +10,5 @@
   public interface IManagedPool<T> : IDisposable where T : class, IPooledObject {
     T Get(bool reset = true);
+    void Release();
   }
 
@@ -17,4 +18,5 @@
     private readonly BinaryFormatter binaryFormatter = new BinaryFormatter();
     private byte[] dummyPartition;
+    private static volatile object dummyCreationLockObject = new object();
 
     private static readonly FieldInfo InternalListArrayProperty = typeof(List<T[]>).GetField(
@@ -37,18 +39,7 @@
     public int InstanceCount { get { return partitions.Count * PartitionSize; } }
 
-    private void InitDummyPartition(Func<T> factory) {
-      var temp = new T[PartitionSize];
-
-      for (var i = 0u; i < PartitionSize; i++) {
-        temp[i] = factory();
-      }
-
-      using (var memoryStream = new MemoryStream()) {
-        binaryFormatter.Serialize(memoryStream, temp);
-        dummyPartition = memoryStream.ToArray();
-      }
-    }
-
     public void Clear() {
+      dummyPartition = null;
+      managedPools.Clear();
       partitions.Clear();
     }
@@ -65,11 +56,30 @@
 
     private T[] CloneDummyPartition() {
-      if (dummyPartition == null)
-        InitDummyPartition(factory);
+      if (dummyPartition == null) {
+        lock (dummyCreationLockObject) {
+          if (dummyPartition == null) {
+            var temp = new T[PartitionSize];
+
+            for (var i = 0u; i < PartitionSize; i++) {
+              temp[i] = factory();
+            }
+
+            using (var memoryStream = new MemoryStream()) {
+              binaryFormatter.Serialize(memoryStream, temp);
+              dummyPartition = memoryStream.ToArray();
+            }
+          }
+        }
+      }
 
       using (var memoryStream = new MemoryStream(dummyPartition)) {
         memoryStream.Seek(0, SeekOrigin.Begin);
 
-        return (T[])binaryFormatter.Deserialize(memoryStream);
+        var result = (T[])binaryFormatter.Deserialize(memoryStream);
+
+        for (var i = 0; i < result.Length; i++)
+          result[i].Init();
+
+        return result;
       }
     }
@@ -102,5 +112,5 @@
       }
 
-      public void Dispose() {
+      public void Release() {
         if (partitions.Count > 0) {
           provider.ReleasePartitions(partitions);
@@ -109,4 +119,8 @@
           entryIndex = provider.PartitionSize;
         }
+      }
+
+      public void Dispose() {
+        Release();
 
         provider.managedPools.Free(this);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ObjectPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ObjectPool.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ObjectPool.cs	(revision 15189)
@@ -6,4 +6,5 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool {
+  using System.Collections.Generic;
   using System.Threading;
 
@@ -102,4 +103,23 @@
       }
     }
+
+    public void Clear() {
+      for (int i = 0; i < _items.Length; i++) {
+        _items[i] = default(Element);
+      }
+    }
+
+    public IEnumerable<T> Items
+    {
+      get
+      {
+        var items = _items;
+        for (var i = 0; i < items.Length; i++) {
+          if (items[i].Value != null) {
+            yield return items[i].Value;
+          }
+        }
+      }
+    }
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs	(revision 15189)
@@ -6,5 +6,11 @@
   [Serializable]
   public class PooledList<T> : List<T>, IPooledObject {
-    public void Reset() {
+    public Guid Id { get; private set; }
+
+    void IPooledObject.Init() {
+      Id = Guid.NewGuid();
+    }
+
+    void IPooledObject.Reset() {
       Clear();
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledObject.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledObject.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledObject.cs	(revision 15189)
@@ -20,4 +20,6 @@
     }
 
+    void IPooledObject.Init() { }
+
     public void Reset() {
       resetor(item);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs	(revision 15189)
@@ -81,5 +81,5 @@
       }
 
-      return new PushProgram(expressions.ToArray());
+      return new PushProgram(expressions.ToList());
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15189)
@@ -151,5 +151,5 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      var chars = interpreter.StringStack.Pop().Reverse().ToArray();
+      var chars = interpreter.StringStack.Pop().Reverse().ToList();
       interpreter.CharStack.Push(chars);
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15189)
@@ -43,10 +43,12 @@
 
     public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    public virtual IDeepCloneable Clone(Cloner cloner) {
       return this;
     }
 
-    public IDeepCloneable Clone(Cloner cloner) {
-      return this;
-    }
+    void IPooledObject.Init() { }
 
     void IPooledObject.Reset() { }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15189)
@@ -25,6 +25,6 @@
 
     static ExpressionTable() {
-      StatelessExpressionTypes = GetExpressionTypes(typeof(StatelessExpression)).ToArray();
-      StatefulExpressionTypes = GetExpressionTypes(typeof(StatefulExpression<>)).ToArray();
+      StatelessExpressionTypes = GetExpressionTypes(typeof(StatelessExpression)).ToList();
+      StatefulExpressionTypes = GetExpressionTypes(typeof(StatefulExpression<>)).ToList();
 
       StatelessExpressionTable = GetStatelessExpressionTable();
@@ -35,5 +35,5 @@
         .Where(t => typeToNameTable.ContainsKey(t))
         .Select(type => typeToNameTable[type])
-        .ToArray();
+        .ToList();
 
       ExpressionCount = StatelessExpressionTable.Count + StatefulExpressionFactory.Count;
@@ -57,6 +57,6 @@
         dictionary.Add(type, expression);
 
-        // do not index hidden expressions like push expression in tables
-        if (attribute.IsHidden) continue;
+        //// do not index hidden expressions like push expression in tables
+        //if (attribute.IsHidden) continue;
 
         indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.Name);
@@ -156,5 +156,5 @@
           .Where(entry => (entry.Key & ~allowedTypes) == 0x0)
           .SelectMany(entry => entry.Value)
-          .ToArray();
+          .ToList();
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs	(revision 15189)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs	(revision 15189)
@@ -0,0 +1,161 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  /// <summary>
+  /// InExpression has a state, but this state is static at compile time and therefore InExpression can be seen as stateless at runtime
+  /// </summary>
+  [StorableClass]
+  public abstract class InExpression : StatelessExpression {
+    private readonly int index;
+
+    protected InExpression(int nr) {
+      this.index = nr - 1;
+    }
+
+    [StorableConstructor]
+    protected InExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return false;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var inputArgument = interpreter.InputExpressions[index];
+
+      inputArgument.Eval(interpreter);
+    }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN1",
+    "Pushes first input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In1Expression : InExpression {
+    public In1Expression() : base(1) { }
+
+    [StorableConstructor]
+    protected In1Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN2",
+    "Pushes second input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In2Expression : InExpression {
+    public In2Expression() : base(2) { }
+
+    [StorableConstructor]
+    protected In2Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+   StackTypes.None,
+   "IN3",
+   "Pushes third input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In3Expression : InExpression {
+    public In3Expression() : base(3) { }
+
+    [StorableConstructor]
+    protected In3Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN4",
+    "Pushes fourth input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In4Expression : InExpression {
+    public In4Expression() : base(4) { }
+
+    [StorableConstructor]
+    protected In4Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN5",
+    "Pushes fifth input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In5Expression : InExpression {
+    public In5Expression() : base(5) { }
+
+    [StorableConstructor]
+    protected In5Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN6",
+    "Pushes sixth input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In6Expression : InExpression {
+    public In6Expression() : base(6) { }
+
+    [StorableConstructor]
+    protected In6Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN7",
+    "Pushes seventh input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In7Expression : InExpression {
+    public In7Expression() : base(7) { }
+
+    [StorableConstructor]
+    protected In7Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN8",
+    "Pushes eighth input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In8Expression : InExpression {
+    public In8Expression() : base(8) { }
+
+    [StorableConstructor]
+    protected In8Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN9",
+    "Pushes nineth input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In9Expression : InExpression {
+    public In9Expression() : base(9) { }
+
+    [StorableConstructor]
+    protected In9Expression(bool deserializing) : base(deserializing) { }
+  }
+
+  [PushExpression(
+    StackTypes.None,
+    "IN10",
+    "Pushes tenth input parameter.",
+    isHidden: true)]
+  [StorableClass]
+  public class In10Expression : InExpression {
+    public In10Expression() : base(10) { }
+
+    [StorableConstructor]
+    protected In10Expression(bool deserializing) : base(deserializing) { }
+  }
+}
